from WMCore.DAOFactory import DAOFactory
from T0.DAS import OverviewCache
from threading import Thread,Lock

class CachedDAOFactory(DAOFactory):
    def __init__(self, package='WMCore', logger=None, dbinterface=None, owner="", timeout=300):
        DAOFactory.__init__(self, package, logger, dbinterface, owner)
        self.timeout=timeout
        self.cache = OverviewCache.OverviewCache('DAOCache')
        self.cacheRunner = Thread(name='DAOcacheRunner', target=self.cache.run)
        self.cacheRunner.start()
        self.lock=Lock()
        

    def __call__(self, classname):
        instance= cachedDAO(self.package,'Oracle',classname,self.logger,self.dbinterface,self.cache,self.timeout)
        return instance
    

        
class cachedDAO():
   classname=""
   object=None
    
   def __init__(self, package, dialect, origClassname,logger=None, dbinterface=None,cache=None,timeout=300):
        self.classname=origClassname
        self.cache=cache
        self.timeout=timeout
        ##  if the classname contains '_' (usually *_count), the class is contained in the file named as the classname until the '_' char [excluded]
        classnameTokens=origClassname.split('_')
        classname=classnameTokens[0] ## 
        module = "%s.%s.%s" % (package, dialect, classname)
        module = __import__(module, globals(), locals(), [classname])#, -1)
        instance = getattr(module, origClassname.split('.')[-1])
        self.object= instance(logger, dbinterface)
            
   def  execute(self, *args, **kwargs):
        key = self.classname+"-"
        for kwarg in kwargs:
            key += kwarg + "=" + kwargs[kwarg] + "-"
        data=self.cache.lockedCacheFetch(key, self.getCurrentData,*args,**kwargs)
        return data
        
        
   def getCurrentData(self, *args, **kwargs):
        return self.object.execute(*args, **kwargs), self.timeout 