#!/usr/bin/env python
"""
_Information on the Repack configuration optionally filtered by run and stream_

T0Mon: this class is used to print the Repack Config Table in the run pages.
"""

from T0.DAS.Database.Oracle.Configs.ExpressStreamConfig import ExpressStreamConfig

class RepackStreamConfig(ExpressStreamConfig):
   
   sql="""
SELECT  
     distinct st.name as stream,
     rc.run_id as run_id,
     rc.proc_version as proc_version,
     cv.name as repversion
     FROM repack_config rc
     INNER JOIN stream st ON  st.id = rc.stream_id
     INNER JOIN run r ON  (r.run_id = rc.run_id)
     INNER JOIN cmssw_version cv ON (cv.id= r.repack_version)
     WHERE %s %s
     ORDER BY stream """
     
   sqlWhereWithRun="rc.run_id= :run "
   sqlWhereWithoutRun=" rc.run_id =(select max(run_id) from repack_config )"
   sqlWhereOptionStreamName= """ AND st.name=:stream"""
   