#!/usr/bin/env python
"""
_Information on  express files by run__

T0Mon: this class is used in the run page [express file table]
"""

from T0.DAS.Database.Oracle.Files.RepackFilesByRun import * 

class ExpressFilesByRun(RepackFilesByRun):

   sqlFileSet="'ExpressDBSUploadable'"
   sql="""SELECT DISTINCT   f.id, f.filesize,  f.events,    f.lfn
      FROM   wmbs_file_details f 
      INNER JOIN    wmbs_fileset_files fsf ON (f.id = fsf.fileid)  
      INNER JOIN wmbs_file_runlumi_map m        ON (f.id               = m.fileid and m.run=:run)  
      WHERE fsf.fileset =  
        (SELECT  wmbs_fileset.id  FROM    wmbs_fileset   WHERE  
             wmbs_fileset.name =%s)  
      ORDER BY  
        1 DESC"""

   def buildQuery(self):
      self.sql=self.sql % (self.sqlFileSet)



class ExpressFilesByRun_count(RepackFilesByRun_count):

   sqlFileSet="'ExpressDBSUploadable'"
   sql="""SELECT COUNT(DISTINCT   f.id)
      FROM   wmbs_file_details f 
      INNER JOIN    wmbs_fileset_files fsf ON (f.id = fsf.fileid)  
      INNER JOIN wmbs_file_runlumi_map m        ON (f.id               = m.fileid and m.run=:run)  
      WHERE fsf.fileset =  
        (SELECT  wmbs_fileset.id  FROM    wmbs_fileset   WHERE  
             wmbs_fileset.name =%s)"""

   def buildQuery(self):
      self.sql=self.sql % (self.sqlFileSet)
