#!/usr/bin/env python
"""
_Information on all the acquired express merge (and their files)_

T0Mon: this class is used in the front page
"""

from T0.DAS.Database.Oracle.LongResultQuery import LongResultQuery 
from WMCore.Database.DBFormatter import DBFormatter

class LastAcquiredExpressMerge(LongResultQuery):
  
   #the query select all the express merge jobs 
   sql="""SELECT                         \
  wmbs_job.id                           AS job_id, \
  wmbs_file_runlumi_map.run             AS run_id,   \
  wmbs_job.state_time                   AS def_time, \
  COUNT(DISTINCT wmbs_job_assoc.fileid) AS inputfiles  \
FROM  wmbs_job  \
JOIN wmbs_jobgroup         ON wmbs_job.jobgroup    = wmbs_jobgroup.id   \
JOIN wmbs_job_assoc        ON wmbs_job.id          = wmbs_job_assoc.job \
JOIN wmbs_file_runlumi_map ON wmbs_job_assoc.fileid    = wmbs_file_runlumi_map.fileid    \
JOIN wmbs_subscription     ON (wmbs_jobgroup.subscription = wmbs_subscription.id)  \
WHERE  \
wmbs_subscription.fileset =  \
( SELECT wmbs_fileset.id FROM wmbs_fileset WHERE wmbs_fileset.name = 'ExpressMergeable') \
AND  wmbs_job.state!=(SELECT id FROM wmbs_job_state WHERE name = 'cleanout' ) \
GROUP BY  \
  wmbs_job.id,   \
  wmbs_job.state_time, \
  wmbs_file_runlumi_map.run \
ORDER BY wmbs_job.id DESC """
     
   def execute(self, uplimit,downlimit, conn = None, transaction = False):
        bindVars = {"uplimit": uplimit,"downlimit": downlimit,}
        result = self.dbi.processData(self.sql, bindVars, conn = conn,
                                      transaction = transaction)
        return self.formatDict(result) 
  
  
######################################################################
class LastAcquiredExpressMerge_count(DBFormatter):
  
   #the query select all the express merge jobs 
   sql="""SELECT                         
 count( distinct  wmbs_job.id )
FROM  wmbs_job  
JOIN wmbs_jobgroup         ON wmbs_job.jobgroup    = wmbs_jobgroup.id   
JOIN wmbs_job_assoc        ON wmbs_job.id          = wmbs_job_assoc.job 
JOIN wmbs_file_runlumi_map ON wmbs_job_assoc.fileid    = wmbs_file_runlumi_map.fileid    
JOIN wmbs_subscription     ON (wmbs_jobgroup.subscription = wmbs_subscription.id)  
WHERE  
wmbs_subscription.fileset =  
( SELECT wmbs_fileset.id FROM wmbs_fileset WHERE wmbs_fileset.name = 'ExpressMergeable') 
AND  wmbs_job.state!=(SELECT id FROM wmbs_job_state WHERE name = 'cleanout' )"""