#!/usr/bin/env python
"""
_Run_

Monitoring DAO classes for Runs in WMBS
"""
__all__ = []
__revision__ = "$Id: Run.py,v 1.2 2010/11/12 10:14:51 hufnagel Exp $"
__version__ = "$Revision: 1.2 $"

from WMCore.Database.DBFormatter import DBFormatter

class Run(DBFormatter):
    
    sql = """SELECT run_id AS run,
                    run.start_time AS start_time,
                    run.end_time AS end_time,
                    run.reco_started AS reco_started,
                    run_status.status AS status
             FROM run
             INNER JOIN run_status ON run.run_status = run_status.id
             ORDER BY run_id
             """
    
    def format(self, result):
        return self.formatDict(result)
