#!/usr/bin/env python
"""
_Get the number of streamers (used by express processes) grouped by run_
T0Mon: % in the front page
"""

from T0.DAS.Database.Oracle.Stats.GeneralNumStat import GeneralNumStat

class NumExpressTotalStreamers(GeneralNumStat):
     
    sql="""
 SELECT COUNT(DISTINCT s.streamer_id) as count,s.run_id as run_id
    FROM streamer s
        INNER JOIN express_config ec ON ( ec.stream_id = s.stream_id AND ec.run_id = s.run_id )
        WHERE 
         s.run_id >=:lowRunId
         and s.run_id <= :highRunId
         group by s.run_id
         order by s.run_id
"""
    #