#!/usr/bin/env python
"""
_number of complete files of the reco process _

T0Mon: % in the front page
"""

from T0.DAS.Database.Oracle.Stats.GeneralNumStat import GeneralNumStat

class NumRecoTemp(GeneralNumStat):
   fileset="'Reconstructable'"
   config="reco_config"
   doFlag="c.do_reco"
   sql="""WITH subscription_id AS (  SELECT id
                 FROM wmbs_subscription
                 WHERE fileset= ( 
                     SELECT id
                     FROM  wmbs_fileset
                    WHERE name=%s ))
SELECT  m.run as run_id,
   COUNT(DISTINCT cf.fileid) AS completed_count,
 COUNT(DISTINCT ff.fileid) AS failed_count
  FROM  wmbs_file_runlumi_map  m  
inner join wmbs_file_dataset_path_assoc a on(a.file_id = m.fileid) 
inner join dataset_path dp on (dp.id =a.dataset_path_id)
inner join %s c on (c.primary_dataset_id = dp.primary_dataset AND c.run_id = m.run ) 
LEFT OUTER JOIN wmbs_sub_files_complete cf ON (cf.fileid =m.fileid AND cf.subscription IN (select * from subscription_id))
LEFT OUTER JOIN wmbs_sub_files_failed ff ON (ff.fileid =m.fileid AND ff.subscription IN (select * from subscription_id))
WHERE 
  %s =1 
  AND m.run>= :lowRunId 
  AND m.run<= :highRunId 
  GROUP BY  m.run 
  ORDER BY  m.run """
 
   def buildQuery(self):
     self.sql=self.sql%(self.fileset,self.config, self.doFlag)
