#!/usr/bin/env python
"""
_Short information about the last streams_

T0Mon: this class is used in the plot generation
"""


from WMCore.Database.DBFormatter import DBFormatter
#
class LastStreamsSummary(DBFormatter): 

   sql="""SELECT stream.name as stream, 
                 streamer.insert_time as time, 
                 wmbs_file_details.filesize as filesize, 
                 wmbs_file_details.events as events
    FROM
    streamer 
    INNER JOIN stream  ON 
       stream.id= streamer.stream_id
    INNER JOIN wmbs_file_details ON 
     wmbs_file_details.id = streamer.streamer_id
    WHERE 
      streamer.insert_time> :stime AND
      streamer.insert_time< :etime 
    ORDER BY 
      streamer.insert_time DESC
    """

  
   def execute(self, stime,etime,conn = None, transaction = False):
        """
        _execute_

        Execute the SQL for the given  statistics and then format and return
        the result.
        """
        bindVars={}
        try:
          bindVars = {"stime": str(stime),"etime": str(etime)}
        except Exception as e:
            return {"Error" : "wrong time"}
        
        result = self.dbi.processData(self.sql, bindVars, conn = conn,
                                      transaction = transaction)
        
        return self.formatDict(result) 
 
 
