from WMCore.Configuration import Configuration
from os import environ
import cherrypy

###############################DAS
cherrypy.config.update({'environment': 'embedded'})
cherrypy.config.update({'server.socket_host': 'vocms115'})
##########################################3
config = Configuration()

config.component_('Webtools')
config.Webtools.port = 8302
config.Webtools.host = 'vocms115.cern.ch'
config.Webtools.application = 'Tier0Monitoring'
config.Webtools.expires=800 
# no caching as general policy, Mott0 has special rules defined in its service  source 
config.component_('Tier0Monitoring')

config.Tier0Monitoring.templates = environ['WMCORE_ROOT'] + '/templates/WMCore/WebTools'
config.Tier0Monitoring.admin = 'your@email.com'
config.Tier0Monitoring.title = 'Tier0 Monitoring'
config.Tier0Monitoring.description = 'Monitoring of a Tier0 instance'

	
config.Tier0Monitoring.section_('views')
# These are all the active pages that Root.py should instantiate
active = config.Tier0Monitoring.views.section_('active')
tier0 = active.section_('tier0')
# The class to load for this view/page
tier0.object = 'WMCore.WebTools.RESTApi'
tier0.templates = environ['WMCORE_ROOT'] + '/templates/WMCore/WebTools/'
tier0.section_("database")
#PRODUCTION
tier0.database.connectUrl = 'oracle://:@'
    
#If you want to set up engineParameters take a look at 
# http://www.sqlalchemy.org/docs/reference/sqlalchemy/connections.html
#tier0.database.engineParameters = {'pool_size': 10, 'max_overflow': 0}

tier0.section_('model')
tier0.model.object = 'T0.DAS.Tier0RESTModel'
tier0.section_('formatter')
tier0.formatter.object = 'WMCore.WebTools.DASRESTFormatter'
tier0.serviceModules = ['T0.DAS.Services.' + x for x in  
                         ['MotT0Service','Tier0RECOService','MonitoringWebpage']]
