#!/usr/bin/env python
#-*- coding: ISO-8859-1 -*-
"""
Rest Model for Tier0 DAS.
"""

from WMCore.WebTools.RESTModel import RESTModel
from WMCore.WMFactory import WMFactory
from T0.DAS.ContentTypeHandler import ContentTypeHandler

class Tier0RESTModel(RESTModel):
    """
    A REST Model for Tier0 Monitoring. Currently only supports monitoring, so only
    implementing the GET verb.
    
    TODO: this can move up to RESTModel Class if I can convince Simon.
    
    """
    def __init__(self, config = {}):
        RESTModel.__init__(self, config)
        
        if hasattr(config, "serviceModules"):
            #TODO: move this out of __init__ possible
            factory = WMFactory('Tire0Services')
            
            for module in config.serviceModules:
                service = factory.loadObject(module, self)
                service.register()
    
    def processParams(self, args, kwargs):
        """
        overwrite base class processParams to handle encoding and decoding
        depending on the content type.
        
        TODO: corrently it only works with cjson not json from python2.6.
        There is issues of converting unit code to string.
        """
        handler = ContentTypeHandler()
        return handler.convertToParam(args, kwargs)